# TensorFlow-Slim example Using IBM Distributed Deep Learning

## About

The `slim/train_image_classifier.py` script utilizes the TensorFlow-Slim image classification model library to train a model with a given dataset. The script has been modified to use IBM Distributed Deep Learning (DDL).

For information on TensorFlow-Slim, as well as how to run the `train_image_classifier.py` script, see: `$CONDA_PREFIX/ddl-tensorflow/examples/slim/README_SLIM.md`.

## Running TensorFlow-Slim example

Before running the TensorFlow-Slim example, make sure there is a conda environment activated with the `ddl-tensorflow` package installed.

The examples should also be copied into a user directory by running the following command:

```bash
$ ddl-tensorflow-install-samples <somedir>
```

The dataset for the TensorFlow-Slim example can be downloaded using the following command:

```bash
$ python download_and_convert_data.py --dataset_name=flowers --dataset_dir=/tmp/slim_dataset_dir
```

To train the `inception_v3` model using the `flowers` dataset on two machines named host1 and host2 that each have 4 GPUs:

```bash
$ ddlrun -H host1,host2 python train_image_classifier.py --max_number_of_steps=100 --dataset_dir=/tmp/slim_dataset_dir --dataset_name=flowers --dataset_split_name=train --model_name=inception_v3
```

&copy; Copyright IBM Corporation 2018, 2019
